﻿using System;
using System.Collections.Generic;
using DTMF_IVR.Model.InputInterpreter;
using Ozeki.VoIP;


namespace DTMF_IVR.Model.IVRMenuElements
{
    internal interface IIVRMenuElement : ICloneable
    {
        /// <summary>
        /// The submenus contain.
        /// </summary>
        Dictionary<object, IIVRMenuElement> SubMenu { get; set; }

        /// <summary>
        /// The current input interpreter.
        /// </summary>
        IInputInterpreter InputInterpreter { get; set; }

        /// <summary>
        /// Activation of the engine.
        /// </summary>
        /// <param name="phoneCall"></param>
        void EngineExecute(IPhoneCall phoneCall);

        /// <summary>
        /// DeActivate of the engine.
        /// </summary>
        void EngineStop();

        /// <summary>
        /// Add a IVRSubmenu.
        /// </summary>
        /// <param name="manuId"></param>
        /// <param name="menuElement"></param>
        /// <param name="inputInterpreter"></param>
        void AddSubMenuElement(object manuId, IIVRMenuElement menuElement, IInputInterpreter inputInterpreter = null);
    }
}